umbrello 2.32.3 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

Public Types | Public Member Functions | Protected Member Functions | Private Attributes | List of all members
UMLArtifact Class Reference

Non-graphical information for a Artifact. More...

`#include <artifact.h>`

Inheritance diagram for UMLArtifact:

## Public Types
enum | Draw_Type { defaultDraw, file, library, table }
Public Types inherited from UMLObject
enum | ObjectType { ot_Unknown = -1, ot_UMLObject = 100, ot_Actor, ot_UseCase, ot_Package, ot_Interface, ot_Datatype, ot_Enum, ot_Class, ot_Instance, ot_Association, ot_Attribute, ot_Operation, ot_EnumLiteral, ot_Template, ot_Component, ot_Artifact, ot_Node, ot_Stereotype, ot_Role, ot_Entity, ot_EntityAttribute, ot_Folder, ot_EntityConstraint, ot_UniqueConstraint, ot_ForeignKeyConstraint, ot_CheckConstraint, ot_Category, ot_Port, ot_InstanceAttribute, ot_SubSystem }

## Public Member Functions
| UMLArtifact (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLArtifact ()
virtual UMLObject * | clone () const
void | saveToXMI1 (QDomDocument &qDoc, QDomElement &qElement)
void | setDrawAsType (Draw_Type type)
Draw_Type | getDrawAsType ()
QString | fullPath () const
Public Member Functions inherited from UMLPackage
| UMLPackage (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLPackage ()
virtual void | copyInto (UMLObject *lhs) const
bool | addObject (UMLObject *pObject, bool interactOnConflict=true)
void | removeObject (UMLObject *pObject)
virtual void | removeAllObjects ()
UMLObjectList | containedObjects (bool includeInactive=false)
void | addAssocToConcepts (UMLAssociation *assoc)
void | removeAssocFromConcepts (UMLAssociation *assoc)
UMLObject * | findObject (const QString &name)
UMLObject * | findObjectById (Uml::ID::Type id)
void | appendPackages (UMLPackageList &packages, bool includeNested=true)
void | appendClassifiers (UMLClassifierList &classifiers, bool includeNested=true)
void | appendClassesAndInterfaces (UMLClassifierList &classifiers, bool includeNested=true)
void | appendEntities (UMLEntityList &entities, bool includeNested=true)
virtual bool | resolveRef ()
Public Member Functions inherited from UMLCanvasObject
| UMLCanvasObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLCanvasObject ()
bool | operator== (const UMLCanvasObject &rhs) const
bool | addAssociationEnd (UMLAssociation *assoc)
bool | hasAssociation (UMLAssociation *assoc)
int | removeAssociationEnd (UMLAssociation *assoc)
void | removeAllAssociationEnds ()
int | associations ()
UMLAssociationList | getAssociations ()
UMLAssociationList | getSpecificAssocs (Uml::AssociationType::Enum assocType)
UMLClassifierList | getSuperClasses (bool withRealizations=true)
UMLClassifierList | getSubClasses ()
virtual UMLAssociationList | getRealizations ()
UMLAssociationList | getAggregations ()
UMLAssociationList | getCompositions ()
UMLAssociationList | getRelationships ()
virtual UMLObject * | findChildObject (const QString &n, UMLObject::ObjectType t=UMLObject::ot_UMLObject)
virtual UMLObject * | findChildObjectById (Uml::ID::Type id, bool considerAncestors=false)
virtual QString | uniqChildName (const UMLObject::ObjectType type, const QString &prefix=QString())
virtual void | removeAllChildObjects ()
UMLObjectList & | subordinates () const
Public Member Functions inherited from UMLObject
| UMLObject (const UMLObject &other)
| UMLObject (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLObject (UMLObject *parent)
| UMLObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLObject ()
bool | operator== (const UMLObject &rhs) const
virtual void | setBaseType (ObjectType ot)
ObjectType | baseType () const
QLatin1String | baseTypeStr () const
virtual void | setID (Uml::ID::Type NewID)
virtual Uml::ID::Type | id () const
QString | doc () const
bool | hasDoc () const
void | setDoc (const QString &d)
void | setVisibility (Uml::Visibility::Enum visibility)
void | setVisibilityCmd (Uml::Visibility::Enum visibility)
Uml::Visibility::Enum | visibility () const
void | setStereotype (const QString &_name)
void | setStereotypeCmd (const QString &_name)
QString | stereotype (bool includeAdornments=false) const
void | setUMLStereotype (UMLStereotype *stereo)
UMLStereotype * | umlStereotype ()
QString | package (const QString &separator=QString(), bool includeRoot=false)
UMLPackageList | packages (bool includeRoot=false) const
bool | setUMLPackage (UMLPackage *pPkg)
UMLPackage * | umlPackage () const
void | setUMLParent (UMLObject *parent)
UMLObject * | umlParent () const
virtual void | setName (const QString &strName)
virtual void | setNameCmd (const QString &strName)
QString | name () const
virtual QString | fullyQualifiedName (const QString &separator=QString(), bool includeRoot=false) const
void | setAbstract (bool bAbstract)
bool | isAbstract () const
virtual bool | showPropertiesDialog (QWidget *parent=0)
virtual bool | loadFromXMI1 (QDomElement &element)
bool | loadStereotype (QDomElement &element)
void | setStatic (bool bStatic)
bool | isStatic () const
virtual bool | acceptAssociationType (Uml::AssociationType::Enum)
void | setSecondaryId (const QString &id)
QString | secondaryId () const
void | setSecondaryFallback (const QString &id)
QString | secondaryFallback () const
QDomElement | save1 (const QString &tag, QDomDocument &qDoc)
bool | isUMLActor ()
bool | isUMLArtifact ()
bool | isUMLAssociation ()
bool | isUMLAttribute ()
bool | isUMLCategory ()
bool | isUMLCheckConstraint ()
bool | isUMLClassifier ()
bool | isUMLComponent ()
bool | isUMLDatatype ()
bool | isUMLEntity ()
bool | isUMLEntityAttribute ()
bool | isUMLEntityConstraint ()
bool | isUMLEnum ()
bool | isUMLEnumLiteral ()
bool | isUMLFolder ()
bool | isUMLForeignKeyConstraint ()
bool | isUMLInstance ()
bool | isUMLInstanceAttribute ()
bool | isUMLNode ()
bool | isUMLObject ()
bool | isUMLOperation ()
bool | isUMLPackage ()
bool | isUMLPort ()
bool | isUMLRole ()
bool | isUMLStereotype ()
bool | isUMLTemplate ()
bool | isUMLUniqueConstraint ()
bool | isUMLUseCase ()
UMLActor * | asUMLActor ()
UMLArtifact * | asUMLArtifact ()
UMLAssociation * | asUMLAssociation ()
UMLAttribute * | asUMLAttribute ()
UMLCanvasObject * | asUMLCanvasObject ()
UMLCategory * | asUMLCategory ()
UMLCheckConstraint * | asUMLCheckConstraint ()
UMLClassifier * | asUMLClassifier ()
UMLClassifierListItem * | asUMLClassifierListItem ()
UMLClassifierSet * | asUMLClassifierSet ()
UMLComponent * | asUMLComponent ()
UMLDatatype * | asUMLDatatype ()
UMLEntity * | asUMLEntity ()
UMLEntityAttribute * | asUMLEntityAttribute ()
UMLEntityConstraint * | asUMLEntityConstraint ()
UMLEnum * | asUMLEnum ()
UMLEnumLiteral * | asUMLEnumLiteral ()
UMLFolder * | asUMLFolder ()
UMLForeignKeyConstraint * | asUMLForeignKeyConstraint ()
UMLInstance * | asUMLInstance ()
UMLInstanceAttribute * | asUMLInstanceAttribute ()
UMLNode * | asUMLNode ()
UMLObject * | asUMLObject ()
UMLOperation * | asUMLOperation ()
UMLPackage * | asUMLPackage ()
UMLPort * | asUMLPort ()
UMLRole * | asUMLRole ()
UMLStereotype * | asUMLStereotype ()
UMLTemplate * | asUMLTemplate ()
UMLUniqueConstraint * | asUMLUniqueConstraint ()
UMLUseCase * | asUMLUseCase ()

## Protected Member Functions
bool | load1 (QDomElement &element)
Protected Member Functions inherited from UMLObject
void | init ()
void | maybeSignalObjectCreated ()

## Private Attributes
Draw_Type | m_drawAsType

## Additional Inherited Members
Public Slots inherited from UMLObject
void | emitModified ()
Signals inherited from UMLCanvasObject
void | sigAssociationEndAdded (UMLAssociation *assoc)
void | sigAssociationEndRemoved (UMLAssociation *assoc)
Signals inherited from UMLObject
void | modified ()
Static Public Member Functions inherited from UMLObject
static QString | toString (ObjectType ot)
static QString | toI18nString (ObjectType t)
static Icon_Utils::IconType | toIcon (ObjectType t)
Protected Attributes inherited from UMLPackage
UMLObjectList | m_objects
Protected Attributes inherited from UMLObject
Uml::ID::Type | m_nId
| object's id More...
QString | m_Doc
| object's documentation More...
QPointer< UMLStereotype > | m_pStereotype
| stereotype of the object if applicable More...
QString | m_name
| objects name More...
ObjectType | m_BaseType
| objects type More...
Uml::Visibility::Enum | m_visibility
| objects visibility More...
bool | m_bAbstract
| state of whether the object is abstract or not More...
bool | m_bStatic
| flag for instance scope More...
bool | m_bInPaste
| caller sets this true when in paste operation More...
bool | m_bCreationWasSignalled
| auxiliary to maybeSignalObjectCreated() More...
QPointer< UMLObject > | m_pSecondary
QString | m_SecondaryId
QString | m_SecondaryFallback
UMLObjectPrivate * | m_d
| private data More...

## Detailed Description

Non-graphical information for a Artifact.

This class contains the non-graphical information required for a UML Artifact. This class inherits from UMLCanvasObject which contains most of the information.

Author
  Jonathan Riddell

See also
  UMLCanvasObject Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Member Enumeration Documentation

## ◆ Draw_Type

enum UMLArtifact::Draw_Type

Artifacts can be drawn using one of several icons.

Enumerator
defaultDraw |
file |
library |
table |

## Constructor & Destructor Documentation

## ◆ UMLArtifact()

UMLArtifact::UMLArtifact | ( | const QString & | name = `QString()`,
|  | Uml::ID::Type | id = `Uml::ID::None`
| ) |  |
| explicit

Sets up an Artifact.

Parameters

  name | The name of the Concept.
  id | The unique id of the Concept.

## ◆ ~UMLArtifact()

UMLArtifact::~UMLArtifact | ( |  | ) |
| virtual

Standard deconstructor.

## Member Function Documentation

## ◆ clone()

UMLObject * UMLArtifact::clone | ( |  | ) | const
| virtual

Make a clone of this object.

Returns
  the cloned object

Reimplemented from UMLPackage.

## ◆ fullPath()

QString UMLArtifact::fullPath | ( |  | ) | const

Return full path of this artifact including its parent

Returns
  full path

## ◆ getDrawAsType()

UMLArtifact::Draw_Type UMLArtifact::getDrawAsType | ( |  | ) |

Returns the value of m_drawAsType.

Returns
  the value of the draw type attribute

## ◆ load1()

bool UMLArtifact::load1 | ( | QDomElement & | element | ) |
| protected virtual

Loads the UML:Artifact element including its operations, attributes and templates.

Parameters

  element | the xml element to load

Returns
  the success status of the operation

Reimplemented from UMLPackage.

## ◆ saveToXMI1()

void UMLArtifact::saveToXMI1 | ( | QDomDocument & | qDoc,
|  | QDomElement & | qElement
| ) |  |
| virtual

Creates the UML:Artifact element including its operations, attributes and templates

Parameters

  qDoc | the xml document
  qElement | the xml element

Reimplemented from UMLPackage.

## ◆ setDrawAsType()

void UMLArtifact::setDrawAsType | ( | Draw_Type | type | ) |

Sets m_drawAsType for which method to draw the artifact as.

Parameters

  type | the draw type

## Member Data Documentation

## ◆ m_drawAsType

Draw_Type UMLArtifact::m_drawAsType
| private

Artifacts can be drawn as one of several different icons, this value choosing how to draw them.

The documentation for this class was generated from the following files:

- umbrello/uml1model/artifact.h
- umbrello/uml1model/artifact.cpp